      Program Central
      Implicit None

      Integer I,Maxhist,Icycle,Icycle2,Ncycle,N

      Parameter (Maxhist = 2000)

      Logical Lran
      Double Precision Generate,P,Delta,Idelta,Dist(Maxhist),Av1,Av2,Av3,X

      Parameter (Delta  = 0.01d0)
      Parameter (Idelta = 1.0d0/Delta)

      Open(21,File="Input",Status="Unknown")
      Read(21,*)
      Read(21,*) Ncycle,N,Lran,P
      Close(21)

      Write(6,*) 'Ncycle         : ',Ncycle
      Write(6,*) 'N              : ',N
      Write(6,*) 'Lran           : ',Lran
      Write(6,*) 'P              : ',P
      Write(6,*)

      Do I=1,Maxhist
         Dist(I) = 0.0d0
      Enddo

      Av1 = 0.0d0
      Av2 = 0.0d0
      Av3 = 0.0d0

      Do Icycle=1,Ncycle
         Do Icycle2=1,1000
            X = Generate(N,P,Lran)

            Av1 = Av1 + X
            Av2 = Av2 + X*X
            Av3 = Av3 + 1.0d0

            I = 1 + Int(X*Idelta)

            If(I.Le.Maxhist) Dist(I) = Dist(I) + 1.0d0
         Enddo
      Enddo

      Write(6,*) 'Average        : ',Av1/Av3
      Write(6,*) 'Sigma          : ',Dsqrt(Dabs((Av2/Av3)-((Av1/Av3)**2)))

      Open(21,File="result.dat",Status="Unknown")
      Do I=1,Maxhist
         If(Dist(I).Gt.0.5d0) Write(21,*) (Dble(I)-0.5d0)*Delta,Dist(I)/Av3
      Enddo
      Close(21)

      Stop
      End

      Function Generate(N,P,Lran)
      Implicit None

      Integer N,I
      Logical Lran
      Double Precision Randomnumber,P,Generate

      Generate = 0.0d0

      Do I=1,N
         If(Lran) Then
            Generate = Generate + Randomnumber()
         Else
            If(Randomnumber().Gt.P) Then
               Generate = Generate + 1.0d0
            Endif
         Endif
      Enddo

      Generate = Generate/Dble(N)
      Return
      End
