      Subroutine Epart(Upot,Uein,X,Y,Z,Cmx,Cmy,Cmz,Ipart)
      Implicit None

      Include 'commons.inc'

C     Compute The Energy Of Particle Ipart

      Integer I,Ipart
      Double Precision Upot,Uein,Dx,Dy,Dz,R2,X,Y,Z,Cmx,Cmy,Cmz

      Upot = 0.0d0
      Uein = 0.0d0
      
      Do I=1,Npart
         If(I.Ne.Ipart) Then
            Dx = Rx(I)-X
            Dy = Ry(I)-Y
            Dz = Rz(I)-Z

C     Periodic Boundary Conditions

            Dx = Dx - Box*Dnint(Dx*Ibox)
            Dy = Dy - Box*Dnint(Dy*Ibox)
            Dz = Dz - Box*Dnint(Dz*Ibox)

            R2 = Dx**2 + Dy**2 + Dz**2

            If(R2.Lt.Rcutsq) Then
               R2   = 1.0d0/R2
               R2   = R2*R2*R2
               Upot = Upot + 4.0d0*R2*(R2-1.0d0) - Ecut
            Endif

            Uein = Uein + 0.5d0*Alpha*((Rx(I)-Rxlat(I)-Cmx)**2 + 
     &                                 (Ry(I)-Rylat(I)-Cmy)**2 + 
     &                                 (Rz(I)-Rzlat(I)-Cmz)**2)
         Else
            Uein = Uein + 0.5d0*Alpha*((X-Rxlat(I)-Cmx)**2 + 
     &                                 (Y-Rylat(I)-Cmy)**2 + 
     &                                 (Z-Rzlat(I)-Cmz)**2)
         Endif
      Enddo

      Return
      End
