      Subroutine Etot(Upot,Uein,Cmx,Cmy,Cmz)
      Implicit None

      Include 'commons.inc'

C     Compute The Energy Of The Complete System

      Integer I,J
      Double Precision Upot,Uein,Dx,Dy,Dz,R2,Cmx,Cmy,Cmz

      Upot = 0.0d0
      Uein = 0.0d0
   
      Do I=1,Npart-1
         Do J=I+1,Npart

            Dx = Rx(I)-Rx(J)
            Dy = Ry(I)-Ry(J)
            Dz = Rz(I)-Rz(J)

C     Periodic Boundary Conditions

            Dx = Dx - Box*Dnint(Dx*Ibox)
            Dy = Dy - Box*Dnint(Dy*Ibox)
            Dz = Dz - Box*Dnint(Dz*Ibox)

            R2 = Dx**2 + Dy**2 + Dz**2

            If(R2.Lt.Rcutsq) Then
               R2   = 1.0d0/R2
               R2   = R2*R2*R2
               Upot = Upot + 4.0d0*R2*(R2-1.0d0) - Ecut
            Endif
         Enddo
      Enddo

      Do I=1,Npart
         Uein = Uein + 0.5d0*Alpha*((Rx(I)-Rxlat(I)-Cmx)**2 + 
     &                              (Ry(I)-Rylat(I)-Cmy)**2 + 
     &                              (Rz(I)-Rzlat(I)-Cmz)**2)
      Enddo

      Return
      End
