      Program Mixture
      Implicit None

      Integer Maxpart,Maxbin

      Parameter (Maxpart = 1000)
      Parameter (Maxbin  = 10000)

      Integer I,Icycle,Ncycle,Icycle2,Icycle3,Npart,Na,Nb
     $     ,Nc

      Double Precision Delta,Randomnumber,Av1,Av2,Av3,Av4,Idelta
     $     ,Avk1,Avk2,Avk3,Dk1(Maxbin),Dk2

      Parameter (Delta = 0.01d0)
      Parameter (Idelta = 1.0d0/Delta)

C     Read Input

      Open(21,File="Input",Status="Unknown")
      Read(21,*)
      Read(21,*) Ncycle,Npart
      Close(21)

C     Check Number Of Particles

      If(Npart.Gt.Maxpart.Or.Npart.Lt.3.Or.Mod(Npart,2).Ne.0)
     &     Stop "Error Npart (Too Few Or Too Many) !!!"
     
      Na = Npart/2
      Nb = Npart/2
      Nc = 0

      Write(6,*) 'Ncycle             : ',Ncycle
      Write(6,*) 'Npart              : ',Npart
      Write(6,*) 'Na                 : ',Na
      Write(6,*) 'Nb                 : ',Nb
      Write(6,*) 'Nc                 : ',Nc
      Write(6,*)
      Write(6,*)

C     Reset Distributions

      Do I=1,Maxbin
         Dk1(I) = 0.0d0
      Enddo

      Dk2   = 0.0d0
      Avk1  = 0.0d0
      Avk2  = 0.0d0
      Avk3  = 0.0d0
      Av1   = 0.0d0
      Av2   = 0.0d0
      Av3   = 0.0d0
      Av4   = 0.0d0

      Open(22,File="Kt",Status="Unknown")

C     Start Of The Simulation

      Do Icycle=1,Ncycle
         Do Icycle2=1,1000
            Do Icycle3=1,Npart

               If(Randomnumber().Lt.0.5d0) Then
                  
                  If(Randomnumber().Lt.
     &                 ((Dble(Na)*Dble(Nb))/(Dble(Nc+1)*Dble(Nc+2)))) Then

                     Na = Na - 1
                     Nb = Nb - 1
                     Nc = Nc + 2
                  Endif
               Else
                  If(Randomnumber().Lt.
     &                 ((Dble(Nc)*Dble(Nc-1))/(Dble(1+Na)*Dble(1+Nb)))) Then
                     Nc = Nc - 2
                     Na = Na + 1
                     Nb = Nb + 1
                  Endif
               Endif

C     Sample Averages

               If(Icycle.Gt.Ncycle/2) Then
                  Av1 = Av1 + Dble(Na)
                  Av2 = Av2 + Dble(Nb)
                  Av3 = Av3 + Dble(Nc)
                  Av4 = Av4 + 1.0d0

                  If(Na.Ne.0) Then
                     Avk1 = Avk1 + Dble(Nc*Nc)/Dble(Na*Nb)
                     Avk2 = Avk2 + (Dble(Nc*Nc)/Dble(Na*Nb))**2
                     Avk3 = Avk3 + 1.0d0

                     I = 1 + Int(Idelta*(Dble(Nc*Nc)/Dble(Na*Nb)))
                     If(I.Le.Maxbin) Dk1(I) = Dk1(I) + 1.0d0
                     Dk2 = Dk2 + 1.0d0
                  Endif
               Endif
            Enddo
         Enddo

         If(Na.Ne.0) Write(22,*) Icycle,Dble(Dble(Nc*Nc)/Dble(Na*Nb))
      Enddo
      
      Close(22)

      Write(6,*) 'Final Na           : ',Na
      Write(6,*) 'Final Nb           : ',Nb
      Write(6,*) 'Final Nc           : ',Nc
      Write(6,*)
      Write(6,*) '<Na>               : ',Av1/Av4
      Write(6,*) '<Nb>               : ',Av2/Av4
      Write(6,*) '<Nc>               : ',Av3/Av4

      Write(6,*) '<Kt>               : ',((Av3/Av4)**2)/((Av1/Av4)*(Av2/Av4))
      Write(6,*) 'Spread <Kt>        : ',
     &     Dsqrt(Dabs((Avk2/Avk3) - ((Avk1/Avk3)**2)))
      
      Open(21,File="DistriKt",Status="Unknown")
      Do I=1,Maxbin
         If(Dk1(I).Gt.0.5d0) Write(21,*) (Dble(I)-0.5d0)*Delta,Dk1(I)/Dk2
      Enddo
      Close(21)

      Stop
      End
