      Program Harmonic
      Implicit None

C     Sets Of Harmonic Oscillators; E Or T Is Constant

      Integer Numberofoscillators,Maxoscillators,Numberofcycles,
     $     Maxenergy,Ninit,Totalenergy,Utot,I,J,K,A,B,Osca,
     $     Oscb,Factor,X1,X2,Y1,Y2,Group,E,L,Np
      
      Parameter (Maxoscillators = 100000)
      Parameter (Maxenergy      = 100000)
      
      Integer Oscillator(Maxoscillators)
      
      Double Precision Randomnumber,Energysum,Count,Energysum2,
     $     Distribution(0:Maxenergy)
      
C     Read Input Parameters

      Open(21,File="Input",Status="Unknown")
      Read(21,*)
      Read(21,*) Numberofcycles,Numberofoscillators,Totalenergy,Group
      Close(21)

      Write(6,*) 'Number Of Cycles                          : ',
     &     Numberofcycles
      Write(6,*) 'Number Of Oscillators                     : ',
     &     Numberofoscillators
      Write(6,*) 'Total Energy                              : ',
     &     Totalenergy
      Write(6,*) 'M                                         : ',
     &     Group
  
      If(Group.Lt.1.Or.Group.Gt.Numberofoscillators) Stop "Error Group"

      If(Numberofcycles.Lt.100) Then
         Write(*,*) 'Please Increase The Number Of Cycles'
         Stop
      Endif
      
      If(Numberofoscillators.Le.3.Or.Numberofoscillators.Ge
     $     .Maxoscillators) 
     &     Stop "Error NumberofOscillators (Too Low Or Too Large)...."
 
      If(Totalenergy.Lt.3.Or.Totalenergy.Ge.Maxenergy) 
     &     Stop "Error Totalenergy (Too Low Or Too Large)...."
            
C     Initialize
      
      Do I=1,Maxoscillators
         Oscillator(I) = 0
      Enddo
      
      Do I=1,Maxenergy
         Distribution(I) = 0.0d0
      Enddo
      
      Ninit         = Numberofcycles/2
      Energysum     = 0.0d0
      Energysum2    = 0.0d0
      Count         = 0.0d0
      Utot          = 0
      
C     Make An Initial Distribution Of The Total
C     Energy Over The Levels

      I = 0
 1    Continue
      I = I + 1
        
      If(I.Gt.Numberofoscillators) I = 1
        
      Oscillator(I) = Oscillator(I) + 1
      Utot = Utot + 1
        
      If(Utot.Ne.Totalenergy) Goto 1
            
C     Calculate Total Initial Energy
      
      Utot = 0
      Np   = 0

      Do I=1,Numberofoscillators
         Utot = Utot + Oscillator(I)
      Enddo

      Write(6,*)
      Write(6,*) 'Initial Energy                            : ',
     &     Utot     
     
C     Loop Over All Cycles

      Open(22,File="Et",Status="Unknown")

      Do I=1,Numberofcycles
         Do J=1,100
            Do K=1,Numberofoscillators

C     Choose 2 Different Levels At Random
C     Exchange Energy At Random

 2             Continue
               Osca = 1 + Int(Dble(Numberofoscillators)*Randomnumber())
               Oscb = 1 + Int(Dble(Numberofoscillators)*Randomnumber())

               If(Osca.Eq.Oscb) Goto 2
              
               If(Randomnumber().Lt.0.5d0) Then
                  A =  1
                  B = -1
               Else
                  A = -1
                  B =  1
               Endif
                  
C     Reject When E<0

               If(Min(Oscillator(Osca)+A,Oscillator(Oscb)+B).Ge.0) Then
                  Oscillator(Osca) = Oscillator(Osca) + A
                  Oscillator(Oscb) = Oscillator(Oscb) + B 
               Endif
            Enddo

C     Sample

            If(I.Ge.Ninit) Then
               E = 0
               Do L=1,Group
                  E = E + Oscillator(L)
               Enddo

               If(Np.Lt.10000000) Then
                  Np = Np + 1
                  Write(22,*) E
               Endif

               Distribution(E) = Distribution(E) + 1.0d0
               Energysum       = Energysum       + Dble(E)
               Energysum2      = Energysum2      + Dble(E)**2
               Count           = Count           + 1.0d0
            Endif
         Enddo

         If(Mod(I,Numberofcycles/99).Eq.0) Then
            J = I/(Numberofcycles/99) - 1

            If(J.Le.99.And.Numberofoscillators.Le.100.And.Utot.Le.500) Then
               Open(21,File="Fig"//Char(48+J/10)//Char(48+Mod(J,10)),Status="Unknown")
               Write(21,'(A)') '#FIG 3.2'
               Write(21,'(A)') 'Landscape'
               Write(21,'(A)') 'Center'
               Write(21,'(A)') 'Inches'
               Write(21,'(A)') 'Letter'
               Write(21,'(A)') '100.00'
               Write(21,'(A)') 'Single'
               Write(21,'(A)') '-2'
               Write(21,'(A)') '1200 2'

               Do J=1,Numberofoscillators

                  Factor = 100

                  Write(21,'(A)') '2 2 0 1 4 4 50 -1 20 0.000 0 0 -1 0 0 5'

                  X1 = 1000 + (J-1)*Factor
                  X2 = X1 + Factor - 1
                  Y1 = 1000 
                  Y2 = Y1 + Oscillator(J)*Factor

                  Write(21,'(10i10)') X1,Y1,X2,Y1,X2,Y2,X1,Y2,X1,Y1
               Enddo
               Close(21)
            Endif
         Endif
      Enddo

      Close(22)

C     Write Results

      Utot = 0

      Do I=1,Numberofoscillators
         Utot = Utot + Oscillator(I)
      Enddo
      
      Write(6,*)
      Write(6,*) 'Final Energy                              : ',
     &     Utot
      Write(6,*)
      Write(6,*)
      Write(6,*) 'Average Energy First M Oscillators        : ',
     &     Energysum/Count
      Write(6,*) 'Standard Deviation First M Oscillators    : ',
     &     Dsqrt(Dabs((Energysum2/Count) - (Energysum/Count)**2))
      Write(6,*)

      Open(21,File='results.dat')

      Do I=0,Maxenergy
         If(Distribution(I).Gt.0.5d0) Then
            Write(21,'(I10,E20.10)') I,Distribution(I)/Count
         Endif
      Enddo
      
      Close(21)
      
      Stop
      End
