      Program Gas
      Implicit None

      Logical Lready
      Integer Maxpart,Maxener

C     Maximum Number Of Particles And Maximum Element Of Kvector

      Parameter (Maxpart = 1000)
      Parameter (Maxener = 100)

      Double Precision Randomnumber,Move1,Move2,Psys2,Psys1(Maxener
     $     ,Maxener,Maxener)

      Integer I,J,K,Icycle,Icycle2,Icycle3,Ncycle,Npart,Kvec(Maxpart,3)
     $     ,Etotal,Esys,Unew,Uold,X1,X2,Y1,Y2,Factor

C     Read Input From Disk

      Open(21,File="Input",Status="Unknown")
      Read(21,*)
      Read(21,*) Ncycle,Npart,Etotal
      Close(21)

      If(Npart.Gt.Maxpart.Or.Npart.Lt.2.Or.Etotal.Le.3*Npart) Stop "Error Input Npart !!!"
      If(Ncycle.Lt.100) Stop "Increase Ncycle !!!"

      Write(6,*) 'Ncycle         : ',Ncycle
      Write(6,*) 'Npart          : ',Npart
      Write(6,*) 'Etotal         : ',Etotal
      Write(6,*)

      Psys2 = 0.0d0

      Do I=1,Maxener
         Do J=1,Maxener
            Do K=1,Maxener
               Psys1(I,J,K) = 0.0d0
            Enddo
         Enddo
      Enddo

C     Set All Particles To Ground State

      Do I=1,Npart
         Kvec(I,1) = 1
         Kvec(I,2) = 1
         Kvec(I,3) = 1
      Enddo

      Move1 = 0.0d0
      Move2 = 0.0d0

C     Set Energy

      Esys = 3*Npart
 
      Write(6,*) 'Esys (Init)    : ',Esys

      Open(21,File="Et",Status="Unknown")

C     Loop Over All Cycles

      Do Icycle=1,Ncycle
         Do Icycle2=1,1000
            Do Icycle3=1,3*Npart

C     Select Random Particle And Random X,Y,Z

               I = 1 + Int(Dble(Npart)*Randomnumber())
               J = 1 + Int(3.0d0*Randomnumber())

               If(Randomnumber().Lt.0.5d0) Then
                  K = 1
               Else
                  K = -1
               Endif

C     Compute Energy Change

               Uold = Kvec(I,1)**2 + Kvec(I,2)**2 + Kvec(I,3)**2
               Kvec(I,J) = Kvec(I,J) + K
               Unew = Kvec(I,1)**2 + Kvec(I,2)**2 + Kvec(I,3)**2

               Move2 = Move2 + 1.0d0

C     Accept Or Reject

               If(Kvec(I,J).Eq.0) Then
                  Lready = .False.
               Elseif((Etotal - (Esys + Unew - Uold)).Ge.0) Then
                  Lready = .True.
               Else
                  Lready = .False.
               Endif

               If(Lready) Then
                  Esys   = Esys + Unew - Uold
                  Move1  = Move1 + 1.0d0
               Else
                  Kvec(I,J) = Kvec(I,J) - K
               Endif

               If(Icycle.Gt.Ncycle/2) Then

C     Update Distribution

                  Psys2 = Psys2 + 1.0d0
                  If(Max(Kvec(1,1),Kvec(1,2),Kvec(1,3)).Le.Maxener)
     &                 Psys1(Kvec(1,1),Kvec(1,2),Kvec(1,3)) = 
     &                 Psys1(Kvec(1,1),Kvec(1,2),Kvec(1,3)) + 1.0d0
               Endif
            Enddo
         Enddo

         Write(21,'(5i12)') Icycle,Kvec(1,1)**2 + Kvec(1,2)**2 + Kvec(1,3)**2,
     &        Kvec(1,1),Kvec(1,2),Kvec(1,3)

C     Write Images

         If(Mod(Icycle,Ncycle/99).Eq.0) Then
            J = Icycle/(Ncycle/99) - 1

            If(J.Le.99.And.Npart.Le.100) Then
               Open(22,File="Fig"//Char(48+J/10)//Char(48+Mod(J,10)),Status="Unknown")
               Write(22,'(A)') '#FIG 3.2'
               Write(22,'(A)') 'Landscape'
               Write(22,'(A)') 'Center'
               Write(22,'(A)') 'Inches'
               Write(22,'(A)') 'Letter'
               Write(22,'(A)') '100.00'
               Write(22,'(A)') 'Single'
               Write(22,'(A)') '-2'
               Write(22,'(A)') '1200 2'

               Do J=1,Npart

                  Factor = 100

                  Write(22,'(A)') '2 2 0 1 4 4 50 -1 20 0.000 0 0 -1 0 0 5'

                  X1 = 1000 + (J-1)*Factor
                  X2 = X1 + Factor - 1
                  Y1 = 1000 
                  Y2 = Y1 + Factor*(Kvec(J,1)**2 + Kvec(J,2)**2 + Kvec(J,3)**2)

                  Write(22,'(10i10)') X1,Y1,X2,Y1,X2,Y2,X1,Y2,X1,Y1
               Enddo
               Close(22)
            Endif
         Endif
      Enddo

      Close(21)

      Write(6,*) 'Accepted       : ',Move1/Move2
      Write(6,*) 'Final Energy   : ',Esys

C     Check Energy Balance

      Esys = 0
      Do I=1,Npart
         Esys = Esys + Kvec(I,1)**2 + Kvec(I,2)**2 + Kvec(I,3)**2
      Enddo

      Write(6,*) 'Final Energy   : ',Esys

C     Write Distribution

      Open(21,File="result.dat",Status="Unknown")
      Do I=1,Maxener
         Do J=1,Maxener
            Do K=1,Maxener
               If(Psys1(I,J,K).Gt.0.5d0) Write(21,'(i10,e20.10,3i10)') 
     &              I*I + J*J + K*K,Psys1(I,J,K)/Psys2,I,J,K
            Enddo
         Enddo
      Enddo
      Close(21)

      Stop
      End
