      Program Entropy
      Implicit None

      Integer Maxpart,Maxener

      Parameter (Maxpart  = 10000)
      Parameter (Maxener  = 10000)
 
      Double Precision Randomnumber,Lnfactorial,Lnw

      Integer I,J,Iener(0:Maxener),Etotal,Ncycle,Npart,Epart(Maxpart)
     $     ,Ia,Ib,Icycle,Icycle2

C     Read Input From Disk

      Open(21,File="Input",Status="Unknown")
      Read(21,*)
      Read(21,*) Ncycle,Npart,Etotal
      Close(21)

      Write(6,*) 'Ncycle                : ',Ncycle
      Write(6,*) 'Npart                 : ',Npart
      Write(6,*) 'Etotal                : ',Etotal
      Write(6,*)

      If(Npart.Gt.Maxpart)  Stop "Npart Too Large !!!"
      If(Etotal.Gt.Maxener) Stop "Etotal Too Large !!!"

C     All Energy In First Particle

      Do I=1,Npart
         Epart(I) = 0
      Enddo
      Epart(1) = Etotal

      Open(21,File="entropy.dat",Status="Unknown")

      Do Icycle=1,Ncycle

C     Exchange Energy Between Particles

         Do Icycle2=1,Npart
 1          Continue
            Ia = 1 + Int(Dble(Npart)*Randomnumber())
            Ib = 1 + Int(Dble(Npart)*Randomnumber())
            If(Ia.Eq.Ib) Goto 1
            If(Epart(Ia)-1.Lt.0) Goto 1

            Epart(Ia) = Epart(Ia) - 1
            Epart(Ib) = Epart(Ib) + 1
         Enddo

C     Calculate System Distribution

         Do I=0,Maxener
            Iener(I) = 0
         Enddo
         Do I=1,Npart
            Iener(Epart(I)) = Iener(Epart(I)) + 1
         Enddo

C     Calculate Ln(W)

         Lnw = Lnfactorial(Npart)
         Do J=0,Maxener
            Lnw = Lnw - Lnfactorial(Iener(J))
         Enddo

         Write(21,*) Icycle,Lnw
      Enddo

      Close(21)

      Open(21,File="systemdist.dat",Status="Unknown")
      Do I=0,Maxener
         If(I.Le.Etotal.And.Iener(I).Ne.0) Write(21,*) I,Iener(I)
      Enddo
      Close(21)
 
      Stop
      End

      Function Lnfactorial(N)
      Implicit None

      Integer I,N
      Double Precision Lnfactorial

      Lnfactorial = 0.0d0

      Do I=2,N
         Lnfactorial = Lnfactorial + Dlog(Dble(I))
      Enddo

      Return
      End
