      Subroutine Init
      Implicit None

      Include 'commons.inc'

C     Generate An Initial Configuration

      Logical Laccept
      Integer I,J,Ipart,Ib
      Double Precision Fac,Randomnumber,Xi,Yi,Zi,Rxn,Ryn,Rzn,Unew,Uold
     $     ,Virnew,Virold

      Fac = Box(1)**3/(Box(1)**3 + Box(2)**3)

      Npbox(1) = 0
      Npbox(2) = 0

C     Generate Random Coordinates And 
C     Place Particles In A Certain Box

      Do I=1,Npart

         If(Nbox.Eq.1) Then
            Ibox(I) = 1
         Else
            If(Randomnumber().Lt.Fac) Then
               Ibox(I) = 1
            Else
               Ibox(I) = 2
            Endif
         Endif

         Npbox(Ibox(I)) = Npbox(Ibox(I)) + 1

         Rx(I) = Box(Ibox(I))*Randomnumber()
         Ry(I) = Box(Ibox(I))*Randomnumber()
         Rz(I) = Box(Ibox(I))*Randomnumber()
      Enddo

C     Monte Carlo Displacements To Remove Initial Overlaps

      Do J=1,Npart*50
         Ipart = 1 + Int(Dble(Npart)*Randomnumber())
         Ib    = Ibox(Ipart)

         Rxn = Rx(Ipart) + Randomnumber() - 0.5d0
         Ryn = Ry(Ipart) + Randomnumber() - 0.5d0
         Rzn = Rz(Ipart) + Randomnumber() - 0.5d0

         If(Rxn.Lt.0.0d0) Then
            Rxn = Rxn + Box(Ib)
         Elseif(Rxn.Gt.Box(Ib)) Then
            Rxn = Rxn - Box(Ib)
         Endif

         If(Ryn.Lt.0.0d0) Then
            Ryn = Ryn + Box(Ib)
         Elseif(Ryn.Gt.Box(Ib)) Then
            Ryn = Ryn - Box(Ib)
         Endif

         If(Rzn.Lt.0.0d0) Then
            Rzn = Rzn + Box(Ib)
         Elseif(Rzn.Gt.Box(Ib)) Then
            Rzn = Rzn - Box(Ib)
         Endif

         Xi = Rx(Ipart)
         Yi = Ry(Ipart)
         Zi = Rz(Ipart)

         Call Epart(Ib,Virold,Uold,Xi,Yi,Zi,Ipart)
         Call Epart(Ib,Virnew,Unew,Rxn,Ryn,Rzn,Ipart)

         Call Accept(Dexp(-0.5d0*(Unew-Uold)),Laccept)

         If(Laccept) Then
            Rx(Ipart) = Rxn
            Ry(Ipart) = Ryn
            Rz(Ipart) = Rzn
         Endif
      Enddo

      Return
      End
