      Program Mc
      Implicit None

C     Monte Carlo In The Npt, Nvt, Muvt, And Gibbs Ensemble

      Include 'commons.inc'

      Logical Linit
      Integer Ncycle,Ninit,Nmove,Iensemble,I,J,Icycle,Icycle2,Dd(2)
      Double Precision Pdisp,Pswap,Pvol,Temp,Deltax,Deltav,V,E,Rm
     $     ,Randomnumber,Dummy,Avv1,Avv2,Avs1,Avs2,Avd1,Avd2,Press

      Avv1 = 0.0d0
      Avv2 = 0.0d0
      Avs1 = 0.0d0
      Avs2 = 0.0d0
      Avd1 = 0.0d0
      Avd2 = 0.0d0

      Open(21,File="Input",Status="Unknown")
      Read(21,*)
      Read(21,*) Ncycle,Ninit,Npart,Linit,Temp,Iensemble
      Read(21,*)
      Read(21,*) Pdisp,Pswap,Pvol
      Read(21,*)
      Read(21,*) Deltax,Deltav,Press
      Read(21,*)
      Read(21,*) Box(1),Box(2)
      Close(21)

      If(Temp.Le.0.0d0)   Stop "Error Temperature !!!"
      If(Pdisp.Le.0.0d0)  Pdisp = 0.0d0
      If(Pvol.Le.0.0d0)   Pvol  = 0.0d0
      If(Pswap.Le.0.0d0)  Pswap = 0.0d0
      If(Deltax.Lt.0.0d0) Stop "Error Deltax !!"
      If(Deltav.Lt.0.0d0) Stop "Error Deltav !!"
      If(Ncycle.Lt.100)   Stop "Minimal 100 Cycles !!!"

      Beta       = 1.0d0/Temp
      Npbox(1)   = 0
      Npbox(2)   = 0

      Rcutsq = (2.5d0)**2
      Ecut   = Rcutsq**3
      Ecut   = 1.0d0/Ecut
      Ecut   = 4.0d0*Ecut*(Ecut-1.0d0)

      Write(6,*) 'Ncycle               : ',Ncycle
      Write(6,*) 'Ninit                : ',Ninit
      Write(6,*) 'Linit                : ',Linit
      Write(6,*) 'Temp                 : ',Temp
      Write(6,*) 'Iens                 : ',Iensemble
      Write(6,*) 'Deltax               : ',Deltax
      Write(6,*) 'Deltav               : ',Deltav
    
C     Iensemble = 1    Nvt   Ensemble
C     Iensemble = 2    Npt   Ensemble
C     Iensemble = 3    Muvt  Ensemble
C     Iensemble = 4    Gibbs Ensemble

      If(Iensemble.Eq.1) Then
         Pswap = 0.0d0
         Pvol  = 0.0d0
         Nbox  = 1

         Write(6,*)
         Write(6,*) 'Nvt Ensemble'
         Write(6,*)

      Elseif(Iensemble.Eq.2) Then
         Pswap = 0.0d0
         Nbox  = 1

         If(Press.Le.0.0d0) Press = 0.0d0

         Write(6,*)
         Write(6,*) 'Npt Ensemble'
         Write(6,*)
         Write(6,*) 'Pressure             : ',Press
         Write(6,*)

      Elseif(Iensemble.Eq.3) Then
         Pvol  = 0.0d0
         Nbox  = 1

         If(Press.Lt.1.0d-100) Stop "Fugacity Too Low In Muvt Ensemble !!!" 

         Write(6,*)
         Write(6,*) 'Muvt Ensemble'
         Write(6,*)
         Write(6,*) 'Mu                   : ',Dlog(Beta*Press)/Beta
         Write(6,*) 'Fugacity             : ',Press
         Write(6,*)
       
      Elseif(Iensemble.Eq.4) Then
         Nbox  = 2

         Write(6,*)
         Write(6,*) 'Gibbs Ensemble'
         Write(6,*)
      Else
         Stop "Error Ensemble !!!"
      Endif

      Dummy = Pdisp + Pswap + Pvol
      Pdisp = Pdisp/Dummy
      Pswap = Pswap/Dummy
      Pvol  = Pvol/Dummy 

      Write(6,*) 'Pdisp                : ',Pdisp
      Write(6,*) 'Pswap                : ',Pswap
      Write(6,*) 'Pvol                 : ',Pvol
     
      Pswap = Pswap + Pvol
      
      If(Linit) Then
         Write(6,*)
         Write(6,*) 'Generate Initial Coordinates'
         Write(6,*)

         If(Npart.Lt.0.Or.Npart.Gt.Maxpart) Stop "Error Npart !!!"
         If(Min(Box(1),Box(2)).Lt.5.0d0) Stop "Boxes Too Small !!!"

         Call Init
      Else
         Write(6,*)
         Write(6,*) 'Read Coordinates From Disk'
         Write(6,*)

         Open(21,File="Coordold",Status="Unknown")
         Read(21,*) Box(1),Box(2)
         Read(21,*) Npart

         If(Npart.Lt.0.Or.Npart.Gt.Maxpart) Stop "Error Npart !!!"
         If(Min(Box(1),Box(2)).Lt.5.0d0) Stop "Boxes Too Small !!!"

         Do I=1,Npart
            Read(21,*) Rx(I),Ry(I),Rz(I),Ibox(I)

            If(Ibox(I).Eq.2.And.Iensemble.Ne.4) Stop "Particle In Wrong Box !!!"

            Npbox(Ibox(I)) = Npbox(Ibox(I)) + 1
         Enddo
      Endif
      
      Write(6,*) 'Box 1                : ',Box(1)
      If(Nbox.Eq.2) Write(6,*) 'Box 2                : ',Box(2)
      Write(6,*) 'Npart                : ',Npart
      Write(6,*) 'Npbox 1              : ',Npbox(1)
      If(Nbox.Eq.2) Write(6,*) 'Npbox 2              : ',Npbox(2)
      Write(6,*) '<Rho1>               : ',Dble(Npbox(1))/(Box(1)**3)
      If(Nbox.Eq.2) 
     &     Write(6,*) '<Rho2>               : ',Dble(Npbox(2))/(Box(2)**3)

      If(Deltax.Gt.0.25d0*Min(Box(1),Box(2))) Stop "Deltax Too Large !!!"

      Etotal(1) = 0.0d0
      Etotal(2) = 0.0d0
      Vtotal(1) = 0.0d0
      Vtotal(2) = 0.0d0

      Do I=1,Nbox
         Call Etot(I,V,E)

         Vtotal(I) = V
         Etotal(I) = E
      Enddo

      Write(6,*)
      Write(6,*) 'Initial Energy Box 1 : ',Etotal(1)
      If(Nbox.Eq.2) Write(6,*) 'Initial Energy Box 2 : ',Etotal(2)
      Write(6,*) 'Initial Virial Box 1 : ',Vtotal(1)
      If(Nbox.Eq.2) Write(6,*) 'Initial Virial Box 2 : ',Vtotal(2)
      Write(6,*)

C     Start Of The Simulation

      Write(6,*)
      Write(6,*)
      Write(6,*) 'The Simulation Is Running.....'
      Write(6,*)
      Write(6,*)

      If(Iensemble.Eq.1) Call Sample_Radial(1)
      Call Sample(1,Iensemble)

      Open(22,File="Traject.xyz",Status="Unknown")
      Open(23,File="Results",Status="Unknown")

      Do Icycle=1,Ncycle

         Nmove = Max(20,Npart)

         Do Icycle2=1,Nmove

C     Select Trial Move At Random

            Rm = Randomnumber()

            If(Rm.Lt.Pvol.And.(Iensemble.Eq.2.Or.Iensemble.Eq.4)) Then

C     Volume Change

               If(Iensemble.Eq.2) Then
                  Call Volume_Npt(Avv1,Avv2,Deltav,Press)
               Else
                  Call Volume_Gibbs(Avv1,Avv2,Deltav)
               Endif

            Elseif(Rm.Lt.Pswap.And.(Iensemble.Eq.3.Or.Iensemble.Eq.4)) Then

C     Particle Swap

               If(Iensemble.Eq.4) Then
                  Call Swap_Gibbs(Avs1,Avs2)
               Else
                  If(Randomnumber().Lt.0.5d0) Then
                     Call Swap_Add(Avs1,Avs2,Press)
                  Else
                     Call Swap_Rem(Avs1,Avs2,Press)
                  Endif
               Endif
           
            Else

C     Particle Displacement

               Call Move(Avd1,Avd2,Deltax)

            Endif

            If(Icycle.Gt.Ninit) Call Sample(2,Iensemble)

         Enddo

         If(Nbox.Eq.2) Then
            Write(23,'(7e20.10)') 
     &           Dble(Icycle),
     &           Dble(Npbox(1))/(Box(1)**3),
     &           Dble(Npbox(2))/(Box(2)**3),
     &           Etotal(1)/Max(0.5d0,Dble(Npbox(1))),
     &           Etotal(2)/Max(0.5d0,Dble(Npbox(2))),
     &           Dble(Npbox(1))/(Beta*(Box(1)**3)) + Vtotal(1)/(3.0d0*(Box(1)**3)),
     &           Dble(Npbox(2))/(Beta*(Box(2)**3)) + Vtotal(2)/(3.0d0*(Box(2)**3))
         Else
            Write(23,'(4e20.10)') 
     &           Dble(Icycle),
     &           Dble(Npbox(1))/(Box(1)**3),
     &           Etotal(1)/Max(0.5d0,Dble(Npbox(1))),
     &           Dble(Npbox(1))/(Beta*(Box(1)**3)) + Vtotal(1)/(3.0d0*(Box(1)**3))
         Endif

         If(Icycle.Gt.Ninit) Then
            If(Iensemble.Eq.1) Call Sample_Radial(2)
            Call Sample(3,Iensemble)
         Endif

         If(Mod(Icycle,Ncycle/100).Eq.0) Then
            Write(22,*) Npart
            Write(22,*)

            Do J=1,Npart
               If(Ibox(J).Eq.2) Then
                  Dummy = 4.0d0*(Box(1) + 2.0d0)
               Else
                  Dummy = 0.0d0
               Endif

               Write(22,'(A,3f15.5)') 'Ar  ',4.0d0*Rx(J)+Dummy,4.0d0*Ry(J),4.0d0*Rz(J)
            Enddo
         Endif
      Enddo

      Close(22)
      Close(23)

      If(Iensemble.Eq.1) Call Sample_Radial(3)
      Call Sample(4,Iensemble)
     
      Write(6,*) 'Frac. Acc. Displ.    : ',Avd1/Max(0.5d0,Avd2)
      Write(6,*) 'Frac. Acc. Swap      : ',Avs1/Max(0.5d0,Avs2)
      Write(6,*) 'Frac. Acc. Volume    : ',Avv1/Max(0.5d0,Avv2)

      Open(21,File="Coordnew",Status="Unknown")
      Write(21,*) Box(1),Box(2)
      Write(21,*) Npart

      Do I=1,Npart
         Write(21,'(3e20.10,i5)') Rx(I),Ry(I),Rz(I),Ibox(I)
      Enddo
      Close(21)

C     Check Energy Calculation

      Do I=1,Nbox
         Call Etot(I,V,E)
       
         Write(6,*)
         Write(6,*) 'Box                  : ',I
         Write(6,*) 'Particles            : ',Npbox(I)
         Write(6,*) 'Box                  : ',Box(I)
         Write(6,*) 'Volume               : ',Box(I)**3
         Write(6,*) 'Rho                  : ',Dble(Npbox(I))/(Box(I)**3)
         Write(6,*) 'Energy               : ',E
         Write(6,*) 'Energy Sim.          : ',Etotal(I)
         Write(6,*) 'Diff                 : ',Dabs(Etotal(I)-E)
         Write(6,*) 'Virial               : ',V
         Write(6,*) 'Virial Sim.          : ',Vtotal(I)
         Write(6,*) 'Diff                 : ',Dabs(Vtotal(I)-V)
         Write(6,*)
      Enddo

      Dd(1) = 0
      Dd(2) = 0

      Do I=1,Npart
         Dd(Ibox(I)) = Dd(Ibox(I)) + 1
      Enddo

      If(Dd(1).Ne.Npbox(1).Or.Dd(2).Ne.Npbox(2)) Then
         Write(6,*) 'Error !!!!'
         Write(6,*) Dd(1),Npbox(1)
         Write(6,*) Dd(2),Npbox(2)
         Stop
      Endif

      Stop
      End
