      Subroutine Init
      Implicit None

      Include 'commons.inc'

C     Generate An Initial Configuration

      Logical Laccept
      Integer I,J,Ipart
      Double Precision Randomnumber,Xi,Yi,Zi,Rxn,Ryn,Rzn,Unew,Uold
     $     ,Virnew,Virold

C     Generate Random Coordinates

      Do I=1,Npart
         Rx(I) = Box*Randomnumber()
         Ry(I) = Box*Randomnumber()
         Rz(I) = Box*Randomnumber()
      Enddo

C     Monte Carlo Displacements To Remove Initial Overlaps

      Do J=1,Npart*50
         Ipart = 1 + Int(Dble(Npart)*Randomnumber())

         Rxn = Rx(Ipart) + Randomnumber() - 0.5d0
         Ryn = Ry(Ipart) + Randomnumber() - 0.5d0
         Rzn = Rz(Ipart) + Randomnumber() - 0.5d0

         If(Rxn.Lt.0.0d0) Then
            Rxn = Rxn + Box
         Elseif(Rxn.Gt.Box) Then
            Rxn = Rxn - Box
         Endif

         If(Ryn.Lt.0.0d0) Then
            Ryn = Ryn + Box
         Elseif(Ryn.Gt.Box) Then
            Ryn = Ryn - Box
         Endif

         If(Rzn.Lt.0.0d0) Then
            Rzn = Rzn + Box
         Elseif(Rzn.Gt.Box) Then
            Rzn = Rzn - Box
         Endif

         Xi = Rx(Ipart)
         Yi = Ry(Ipart)
         Zi = Rz(Ipart)

         Call Epart(Virold,Uold,Xi,Yi,Zi,Ipart)
         Call Epart(Virnew,Unew,Rxn,Ryn,Rzn,Ipart)

         Call Accept(Dexp(-0.5d0*(Unew-Uold)),Laccept)

         If(Laccept) Then
            Rx(Ipart) = Rxn
            Ry(Ipart) = Ryn
            Rz(Ipart) = Rzn
         Endif
      Enddo

      Return
      End
