      Subroutine Init
      Implicit None
 
      Include 'system.inc'
 
C     Generates Initial Positions/Velocities
 
      Logical Laccept
      Integer I,J,Ipart
 
      Double Precision RandomNumber,Rangauss,Impx,Impy,Impz,Rxn
     $     ,Ryn,Rzn,Diff,Uo,Un
 
C     Generate Velocities From A Gaussian; Set Impulse To Zero
C     Put Particles At Random In The Box

      Impx = 0.0d0
      Impy = 0.0d0
      Impz = 0.0d0
     
      Do I = 1,NumberOfParticles
         Vxx(I) = Dsqrt(Temperature)*Rangauss()
         Vyy(I) = Dsqrt(Temperature)*Rangauss()
         Vzz(I) = Dsqrt(Temperature)*Rangauss()
         Impx = Impx + Vxx(I)
         Impy = Impy + Vyy(I)
         Impz = Impz + Vzz(I)

         Rxx(I) = Box*Randomnumber()
         Ryy(I) = Box*Randomnumber()
         Rzz(I) = Box*Randomnumber()
      Enddo
 
      Impx = Impx/Dble(NumberOfParticles)
      Impy = Impy/Dble(NumberOfParticles)
      Impz = Impz/Dble(NumberOfParticles)

      Do I = 1,NumberOfParticles
         Vxx(I) = Vxx(I) - Impx
         Vyy(I) = Vyy(I) - Impy
         Vzz(I) = Vzz(I) - Impz
      Enddo
 
C     Calculate Better Positions Using Mc Algorithm
C     Displace Randomly Selected Particles
 
      Do J = 1,250*Numberofparticles
         Ipart = 1 + Int(Dble(Numberofparticles)*Randomnumber())
         Rxn   = Rxx(Ipart)
         Ryn   = Ryy(Ipart)
         Rzn   = Rzz(Ipart)
         
         Call Epart(Ipart,Uo,Rxn,Ryn,Rzn)

         Rxn = Rxx(Ipart) + Randomnumber() - 0.5d0
         Ryn = Ryy(Ipart) + Randomnumber() - 0.5d0
         Rzn = Rzz(Ipart) + Randomnumber() - 0.5d0

         If(Rxn.Lt.0.0d0) Then
            Rxn = Rxn + Box
         Elseif(Rxn.Gt.Box) Then
            Rxn = Rxn - Box
         Endif
         
         If(Ryn.Lt.0.0d0) Then
            Ryn = Ryn + Box
         Elseif(Ryn.Gt.Box) Then
            Ryn = Ryn - Box
         Endif

         If(Rzn.Lt.0.0d0) Then
            Rzn = Rzn + Box
         Elseif(Rzn.Gt.Box) Then
            Rzn = Rzn - Box
         Endif

         Call Epart(Ipart,Un,Rxn,Ryn,Rzn)

         Diff = (Uo - Un)/Temperature

         If(Diff.Gt.0.0d0) Then
            Laccept = .True.
         Elseif(Diff.Lt.-50.0d0) Then
            Laccept = .False.
         Else
            If(Randomnumber().Lt.Dexp(Diff)) Then
               Laccept = .True.
            Else
               Laccept = .False.
            Endif
         Endif

         If(Laccept) Then
            Rxx(Ipart) = Rxn
            Ryy(Ipart) = Ryn
            Rzz(Ipart) = Rzn
         Endif
      Enddo
 
C     Store Initial Positions
 
      Do I = 1,NumberOfParticles
         Mxx(I) = Rxx(I)
         Myy(I) = Ryy(I)
         Mzz(I) = Rzz(I)
      Enddo
 
      Call Force
      Write (6,*) 'Initial Energy        : ',Potentialenergy
 
      Return
      End
