      Subroutine Integrate(Ic)
      Implicit None
 
      Include 'system.inc'
 
C     Integrate The Equations Of Motion; Velocity-Verlet Algorithm
 
      Integer I,Ic
      Double Precision Impx,Impy,Impz,Randomnumber,Rangauss

      If(Ic.Eq.1) Then

C     1st Part Of Velocity Verlet

         Do I = 1,Numberofparticles
            Mxx(I) = Mxx(I) + Timestep*Vxx(I) + 0.5d0*Timestep2*Fxx(I)
            Myy(I) = Myy(I) + Timestep*Vyy(I) + 0.5d0*Timestep2*Fyy(I)
            Mzz(I) = Mzz(I) + Timestep*Vzz(I) + 0.5d0*Timestep2*Fzz(I)

            Rxx(I) = Rxx(I) + Timestep*Vxx(I) + 0.5d0*Timestep2*Fxx(I)
            Ryy(I) = Ryy(I) + Timestep*Vyy(I) + 0.5d0*Timestep2*Fyy(I)
            Rzz(I) = Rzz(I) + Timestep*Vzz(I) + 0.5d0*Timestep2*Fzz(I)

C     Put Particles Back In The Box

            If (Rxx(I).Gt.Box) Then
               Rxx(I) = Rxx(I) - Box
            Elseif (Rxx(I).Lt.0.0d0) Then
               Rxx(I) = Rxx(I) + Box
            Endif
 
            If (Ryy(I).Gt.Box) Then
               Ryy(I) = Ryy(I) - Box
            Elseif (Ryy(I).Lt.0.0d0) Then
               Ryy(I) = Ryy(I) + Box
            Endif
 
            If (Rzz(I).Gt.Box) Then
               Rzz(I) = Rzz(I) - Box
            Elseif (Rzz(I).Lt.0.0d0) Then
               Rzz(I) = Rzz(I) + Box
            Endif

            Vxx(I) = Vxx(I) + Timestep*Fxx(I)
            Vyy(I) = Vyy(I) + Timestep*Fyy(I)
            Vzz(I) = Vzz(I) + Timestep*Fzz(I)
         Enddo

      Else

C     2nd Part Of Velocity Verlet Algorithm; Apply Andersen Thermostat

         Kineticenergy = 0.0d0
         Impx = 0.0d0
         Impy = 0.0d0
         Impz = 0.0d0

         Do I = 1,Numberofparticles
            Vxx(I) = Vxx(I) + 0.5d0*Timestep*Fxx(I)
            Vyy(I) = Vyy(I) + 0.5d0*Timestep*Fyy(I)
            Vzz(I) = Vzz(I) + 0.5d0*Timestep*Fzz(I)

C     Random Colision

            If(Randomnumber().Lt.Freqandersen*Timestep) Then
               Vxx(I) = Rangauss()*Dsqrt(Temperature)
               Vyy(I) = Rangauss()*Dsqrt(Temperature)
               Vzz(I) = Rangauss()*Dsqrt(Temperature)
            Endif

            Impx = Impx + Vxx(I)
            Impy = Impy + Vyy(I)
            Impz = Impz + Vzz(I)
 
            Kineticenergy = Kineticenergy + (Vxx(I)*Vxx(I) + Vyy(I)*Vyy(I) 
     &           + Vzz(I)*Vzz(I))
         Enddo

C     Set Total Impulse To Zero

         Impx = Impx/Dble(Numberofparticles)
         Impy = Impy/Dble(Numberofparticles)
         Impz = Impz/Dble(Numberofparticles)

         Do I = 1,Numberofparticles
            Vxx(I) = Vxx(I) - Impx
            Vyy(I) = Vyy(I) - Impy
            Vzz(I) = Vzz(I) - Impz
         Enddo
      Endif

      Return
      End
