      Subroutine Mdloop
      Implicit None
 
      Include 'system.inc'
 
      Integer I,J
      Double Precision Av(6),Utot0,Dutot,Tempz
 
      Do I = 1,6
         Av(I) = 0.0d0
      Enddo

      Dutot=0.0d0

C     Initialize Radial Distribution Function
C     Initialize Diffusion Coefficient

      Call Sample_Radial(1)
      Call Sample_Diff(1)
      Call Sample_Velocity(1)

C     Loop Over All Cycles

      Open(21,File="Traject.xyz",Status="Unknown")

      Do I = 1,Numberofsteps
 
C     Integrate The Equations Of Motion; 1st Part
 
         Call Integrate(1)

C     Calculate The Force
 
         Call Force

C     Integrate The Equations Of Motion; 2nd Part
 
         Call Integrate(2)

C     Add The Kinetic Part Of The Pressure

         Pressure = Pressure + 2.0d0*Kineticenergy*Dble(Numberofparticles)/
     &        (Box*Box*Box*Dble(3*Numberofparticles-3))

         If (I.Eq.1) Then
            Write (6,*)
            Write (6,*)
            Write (6,'(3a)') '    Step  Totalenergy  Kineticenergy',
     &           '  Potentialenergy  Temperature  Pressure'
            Write (6,*)
         Endif
 
         Totalenergy = Kineticenergy + Potentialenergy

C     Choose A Starting Point To Calculate The Energy Drift
C     Declare Utot0

         If(I.Eq.Numberofinitsteps) Utot0=Totalenergy
 
         Tempz = 2.0d0*Kineticenergy/Dble(3*Numberofparticles - 3)
 
         If (I.Gt.Numberofinitsteps.And.Mod(I,500).Eq.0) 
     &        Write (6,'(I8,8(2x,E12.5))') I,Totalenergy,Kineticenergy,
     &        Potentialenergy,Tempz,Pressure

         If(Mod(I,Numberofsteps/100).Eq.0) Then
            Write(21,*) Numberofparticles
            Write(21,*)
            Do J=1,Numberofparticles
               Write(21,'(A,3f15.5)') 
     &              'Ar  ',4.0d0*Rxx(J),4.0d0*Ryy(J),4.0d0*Rzz(J)
            Enddo
         Endif
 
C     Calculate Averages
 
         If (I.Gt.Numberofinitsteps) Then
            Av(1) = Av(1) + Tempz
            Av(2) = Av(2) + Pressure
            Av(3) = Av(3) + Kineticenergy
            Av(4) = Av(4) + Potentialenergy
            Av(5) = Av(5) + Totalenergy
            Av(6) = Av(6) + 1.0d0

C     Update The Energy Drift
C     Declare Dutot And Initialise It

            Dutot = Dutot + Dabs((Utot0-Totalenergy)/Utot0)

C     Sample Radial Distribution Function

            If(Mod(I,100).Eq.0) Call Sample_Radial(2)

            Call Sample_Diff(2)
            Call Sample_Velocity(2)
         Endif
      Enddo

      Close(21)
 
C     Print Averages To Screen
 
      If (Av(6).Gt.0.5d0) Then
         Av(6) = 1.0d0/Av(6)
         Do I = 1,5
            Av(I) = Av(I)*Av(6)
         Enddo
 
         Write (6,*)
         Write (6,*) 'Average Temperature     : ',Av(1)
         Write (6,*) 'Average Pressure        : ',Av(2)
         Write (6,*) 'Average Kineticenergy   : ',Av(3)
         Write (6,*) 'Average Potentialenergy : ',Av(4)
         Write (6,*) 'Average Totalenergy     : ',Av(5)

C     Print The Average Energy Drift
         Write (6,*) 'Average Drift Delta U   : ',Dutot*Av(6)
      Endif

      Call Sample_Radial(3)
      Call Sample_Diff(3)
      Call Sample_Velocity(3)


      Return
      End
