      Subroutine Readdat
      Implicit None
 
      Include 'system.inc'
 
C     Read In System Information

      Open (21,File="Input",Status="Unknown")
      Read (21,*) Box,Numberofparticles,Numberofsteps,Temperature,
     &     Timestep,Numberofinitsteps,Freqandersen
      Close (21)

      If (Numberofparticles.Gt.Maxparticles.Or.Numberofparticles.Le.1) Then
         Write (6,*) 'Maximum No. Of Particles Is : ',Maxparticles
         Stop
      Endif
 
C     Calculate Some Parameters
 
      If(Box.Lt.5.0d0) Stop "Error !! Box Too Samll !!"

      Halfbox = 0.5d0*Box
      Rcutsq  = (2.5d0)**2
      Ecut    = 4.0d0*((Rcutsq**(-6.0d0)) - (Rcutsq**(-3.0d0)))
 
      Timestep2 = Timestep*Timestep
       
C     Print Information To The Screen
 
      Write(6,*) 'Molecular Dynamics Program'
      Write(6,*)
      Write(6,*) 'Number Of Particles   : ',Numberofparticles
      Write(6,*) 'Boxlength             : ',Box
      Write(6,*) 'Density               : ',Dble(Numberofparticles)/(Box*Box*Box)
      Write(6,*) 'Temperature           : ',Temperature
      Write(6,*) 'Cut-Off Radius        : ',Dsqrt(Rcutsq)
      Write(6,*) 'Cut-Off Energy        : ',Ecut
      Write(6,*) 'Number Of Steps       : ',Numberofsteps
      Write(6,*) 'Number Of Init Steps  : ',Numberofinitsteps
      Write(6,*) 'Timestep              : ',Timestep
      Write(6,*) 'Frequency Andersen    : ',Freqandersen
 
      If(Temperature.Le.0.0d0) Stop "Temperature Too Low !!!"

      Return
      End
