      Subroutine Sample_Diff(Switch)
      Implicit None

      Include 'system.inc'

C     Tmax  = Maximum Timesteps For The Correlation Time
C     T0max = Maximum Number Of Time Origins 

      Integer   Tmax,T0max

      Parameter (Tmax=7500)
      Parameter (T0max=250)

      Integer Ttel,Tt0(T0max),T0,Switch,I,T,Tvacf,Dt

      Double Precision Vxt0(MaxParticles,T0max),Vyt0(MaxParticles,T0max),
     &                 Vzt0(MaxParticles,T0max),Vacf(Tmax),R2t(Tmax),
     &                 Rx0(MaxParticles,T0max),Ry0(MaxParticles,T0max),
     &                 Rz0(MaxParticles,T0max),Nvacf(Tmax),Intt,Dtime
       
      Save Vacf,Nvacf,Vxt0,Vyt0,Vzt0,Tvacf,R2t,Rx0,
     &     Ry0,Rz0,Tt0,T0
       
      If (Switch.Eq.1) Then

C     Initialize Everything

         Tvacf = 0
         T0    = 0

         Do I = 1, Tmax
            R2t(I)   = 0.0d0
            Nvacf(I) = 0.0d0
            Vacf(I)  = 0.0d0
         Enddo

      Elseif(Switch.Eq.2) Then

         Tvacf = Tvacf + 1

         If (Mod(Tvacf,50).Eq.0) Then

C     New Time Origin                                         
C     Store The Positions/Velocities; The Current Velocities  
C     Are Vxx(I) And The Current Positions Are Mxx(I).        
C     Question: Why Do You Have To Be Careful With Pbc ?      

            T0         = T0 + 1
            Ttel       = Mod(T0-1, T0max) + 1
            Tt0(Ttel)  = Tvacf

C     Store Particle Positions/Velocities
C     Question: Why Do We Use Mxx Instead Of Rxx ?????

            Do I = 1, NumberOfParticles
               Rx0(I,Ttel)  = Mxx(I)
               Ry0(I,Ttel)  = Myy(I)
               Rz0(I,Ttel)  = Mzz(I)
               Vxt0(I,Ttel) = Vxx(I)
               Vyt0(I,Ttel) = Vyy(I)
               Vzt0(I,Ttel) = Vzz(I)
            Enddo
         Endif

C     Loop Over All Time Origins That Have Been Stored

         Do T = 1, Min(T0, T0max)
            Dt = Tvacf - Tt0(T) + 1

C     Only If The Time Difference Is Shorter Than The Maximum Correlation Time

            If (Dt.Lt.Tmax) Then
               Nvacf(Dt) = Nvacf(Dt) + 1.0d0
                  
               Do I = 1, NumberOfParticles
                  Vacf(Dt) = Vacf(Dt) + Vxx(I)*Vxt0(I,T) + 
     &                                  Vyy(I)*Vyt0(I,T) + 
     &                                  Vzz(I)*Vzt0(I,T)

                  R2t(Dt)  = R2t(Dt)  + (Mxx(I)-Rx0(I,T))**2 + 
     &                                  (Myy(I)-Ry0(I,T))**2 + 
     &                                  (Mzz(I)-Rz0(I,T))**2
               Enddo
            Endif
         Enddo

      Else

Ccccccccccccccccccccccccccccccccccc
C     Write Everything To Disk    C
Ccccccccccccccccccccccccccccccccccc

         Intt = 0.0d0

         Open(21,File="Vacf",Status="Unknown")
         Open(22,File="Msd",Status="Unknown")

         Do I = 1, Tmax-1
                           
            Dtime = Dble(I-1)*TimeStep

            If (Nvacf(I).Ge.0.5d0) Then
               Vacf(I) = Vacf(I)/(Dble(NumberOfParticles)*Nvacf(I))
               R2t(I)  = R2t(I) /(Dble(NumberOfParticles)*Nvacf(I))
            Else
               Vacf(I) = 0.0d0
               R2t(I)  = 0.0d0
            Endif

            Intt = Intt + TimeStep*Vacf(I)/3.0d0

            Write(21,*) Dtime,Vacf(I),Intt
            
            If(I.Ne.1) Then
               Write(22,*) Dtime,R2t(I),R2t(I)/(6.0d0*Dtime)
            Else
               Write(22,*) Dtime,R2t(I),' 0.0d0'
            Endif
         Enddo
         Close(21)
         Close(22)
      Endif

      Return
      End
