      Subroutine Sample_Velocity(Ic)
      Implicit None

      Include 'system.inc'

      Integer Ic,I,J,Maxbin
      
      Parameter (Maxbin = 10000)

      Double Precision Avx(-Maxbin:Maxbin),Avy(-Maxbin:Maxbin),Avz(
     $     -Maxbin:Maxbin),Av2,Delta,Idelta

      Parameter (Delta  = 0.01d0)
      Parameter (Idelta = 1.0d0/Delta)

      Save Avx,Avy,Avz,Av2

      If(Ic.Eq.0) Then
         Av2 = 0.0d0

         Do I=-Maxbin,Maxbin
            Avx(I) = 0.0d0
            Avy(I) = 0.0d0
            Avz(I) = 0.0d0
         Enddo

      Elseif(Ic.Eq.2) Then
         Av2 = Av2 + Dble(Numberofparticles)*Delta
         
         Do I=1,Numberofparticles
            J = Nint(Vxx(I)*Idelta)
            If(Abs(J).Le.Maxbin) Avx(J) = Avx(J) + 1.0d0
            J = Nint(Vyy(I)*Idelta)
            If(Abs(J).Le.Maxbin) Avy(J) = Avy(J) + 1.0d0
            J = Nint(Vzz(I)*Idelta)
            If(Abs(J).Le.Maxbin) Avz(J) = Avz(J) + 1.0d0
         Enddo
      Else
         Open(21,File="Velocity",Status="Unknown")
         Do I=-Maxbin,Maxbin
            Write(21,'(4e20.10)') Delta*Dble(I),Avx(I)/Av2,Avy(I)/Av2,Avz(I)/Av2
         Enddo
         Close(21)
      Endif

      Return
      End
